package org.seasar.timer;

import java.lang.reflect.Method;
import java.util.TimerTask;
import org.seasar.framework.log.Logger;
import org.seasar.framework.util.ClassUtil;
import org.seasar.framework.util.MethodUtil;

public class MethodInvokerTimerTask extends TimerTask {
    private final static Logger logger = Logger.getLogger(MethodInvokerTimerTask.class);
    private Object component;
    private String methodName;

    public MethodInvokerTimerTask() {
    }

    public MethodInvokerTimerTask(Object component, String methodName) {
	setComponent(component);
	setMethod(methodName);
    }

    public void setComponent(Object component) {
	this.component = component;
    }

    public void setMethod(String methodName) {
	this.methodName = methodName;
    }

    public void run() {
 	try {
 	    Method method = ClassUtil.getMethod(component.getClass(), methodName, null);
 	    MethodUtil.invoke(method, component, null);
 	} catch (Throwable t) {
 	    logger.log(t);
 	}
    }
}
